<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2012 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component 
 * @copyright Copyright (C) Ilya Guk www.avtodispetcher.ru
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.filesystem.folder' );
jimport( 'joomla.version' );

$version = new JVersion();
$joomla_ver = $version->getHelpVersion();

if ($joomla_ver <= '0.15'){
	define("JOOMLA_LEGACY_VERSION"		, true);
	define('JOOMLA_MENU_NAME' 			, 'name');
	define("JOOMLA_MENU_COMPONENT_ID"	, 'componentid');
} elseif ($joomla_ver >= '0.16') {
	//Joomla version 1.6 and later
	define("JOOMLA_LEGACY_VERSION"		, false);
	define('JOOMLA_MENU_NAME' 			, 'title');
	define("JOOMLA_MENU_COMPONENT_ID"	, 'component_id');
}


function addMenuItems()
{
	$db = JFactory::getDBO();

	// Does the menu alredy exist?
	$query 	= 'SELECT * FROM #__menu WHERE published=1 AND link LIKE "%option=com_avtodispetcher%"';
 	$db->setQuery($query);
    $menus 	= $db->loadAssocList();
    //print_r($menus);
    if (count($menus)>0)
    {
     	return true;
    }

    $query 	= 'SELECT * FROM #__components WHERE `option` LIKE "%com_avtodispetcher%" LIMIT 1';
	$db->setQuery( $query );
	//$component		= JComponentHelper::getComponent('com_avtodispetcher'); - does not work well
	$component 	= $db->loadAssoc();
	//print_r($component);
	$component_id	= 0;
	if (is_array($component) && (isset($component['id'])))
	{
		$component_id 	= $component['id'];
	}

	if ($component_id==0) return;

	$column_name	= JOOMLA_MENU_NAME;
	$column_cid		= JOOMLA_MENU_COMPONENT_ID;

	// $defaultMenuType	= JFactory::getApplication('sites')->getMenu()->getDefault()->menutype;
	jimport('joomla.application.application');
	$defaultMenuType	= JApplication::getInstance('site')->getMenu()->getDefault('workaround_joomla_bug')->menutype;

	$query 	= 'SELECT ' . $db->nameQuote( 'ordering' ) . ' '
			. 'FROM ' . $db->nameQuote( '#__menu' ) . ' '
			. 'ORDER BY ' . $db->nameQuote( 'ordering' ) . ' DESC LIMIT 1';
	$db->setQuery( $query );
	$order 	= $db->loadResult() + 1;

	// Update the existing menu items.
	$row		= JTable::getInstance ( 'menu', 'JTable' );

	$row->menutype = $defaultMenuType;
	$row->$column_name = 'Расчет Расстояний';
	$row->alias = 'Avtodispetcher';
	$row->link = 'index.php?option=com_avtodispetcher&view=distance';
	$row->type = 'component';
	$row->published = '1';
	$row->$column_cid = $component_id;
	$row->ordering = $order;
	$row->id = null; //new item

	if (!JOOMLA_LEGACY_VERSION)
	{
		$row->language	= '*';
	}

	$row->check();

	if(!$row->store())
	{
		return false;
	}

	//for version 1.6 only. The parent_id is not updated correctly via JTable
	if (!JOOMLA_LEGACY_VERSION)
	{
		$query = 'UPDATE '. $db->nameQuote( '#__menu' )
				 . ' SET `parent_id` = ' .$db->quote(1)
				 . ', `level` = ' . $db->quote(1)
				 . ' WHERE `id` = ' . $db->quote($row->id) ;
		$db->setQuery( $query );
		$db->query();
		if($db->getErrorNum())
		{
			return false;
		}
	}

	return true;
}

function com_install()
{
  $r = addMenuItems();
}
?>